


#include "ListOfHandlers.h"


///////////////////////////////////////////////////////////
// This function adds a new handler to the list.
// From this time on, the new handler is governed
// by the list.
///////////////////////////////////////////////////////////
//		
// INPUT:
//			orphan_handler - a pointer to the THandler
//				object (or derived)
//		
// OUTPUT:
//			none
//		
// REMARKS:
//			The orphan_handler object is orphaned on
//				behalf of this list, so the list
//				will destroy it in its destructor.
//		
void TListOfHandlers::Add2Head( THandler * orphan_handler )
{
	if( orphan_handler == 0 )
		return;						// we cannot add 0 

	orphan_handler->SetNext( fHead );
	fHead = orphan_handler;
}


///////////////////////////////////////////////////////////
// This function returns ptr to the first element in 
// the list and it starts the iteration process.
///////////////////////////////////////////////////////////
//		
// INPUT:
//			none
//		
// OUTPUT:
//			ptr to the head
//		
// REMARKS:
//		
//		
THandler * TListOfHandlers::GetFirst( void )
{
	return fIteratorCurrentPosition = fHead;
}

///////////////////////////////////////////////////////////
// This function returns ptr to the next
///////////////////////////////////////////////////////////
//		
// INPUT:
//		
//		
// OUTPUT:
//		
//		
// REMARKS:
//		
//		
THandler * TListOfHandlers::GetNext( void )
{
	if( fIteratorCurrentPosition == 0 )
		return 0;
	else
		return fIteratorCurrentPosition = fIteratorCurrentPosition->GetNext();
}
